library ieee;
use ieee.std_logic_1164.all;

entity ChangeDetector is
    port (
        Clk_ik: in std_logic;
        Signal_ib: in std_logic_vector;
        Change_o: out std_logic
    );
end entity;

architecture syn of ChangeDetector is
    
    signal History_b: std_logic_vector(Signal_ib'range) := (others => '0');
    
begin
    
    pDelay: process (Clk_ik) is begin
        if rising_edge(Clk_ik) then
            History_b <= Signal_ib;
        end if;
    end process;
    
    pDetection: process (Signal_ib, History_b) is
        variable Result: std_logic;
    begin
        Result := '0';
        for i in Signal_ib'range loop
            Result := Result or (Signal_ib(i) xor History_b(i));
        end loop;
        Change_o <= Result;
    end process;
    
end architecture;
