---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for FMC DEL 1ns 2cha core registers
---------------------------------------------------------------------------------------
-- File           : ../rtl/ffpg_csr.vhd
-- Author         : auto-generated by wbgen2 from ffpg_csr.wb
-- Created        : 12/19/16 17:04:33
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE ffpg_csr.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.wbgen2_pkg.all;

use work.ffpg_wbgen2_pkg.all;


entity ffpg_csr is
  port (
    rst_n_i                                  : in     std_logic;
    clk_sys_i                                : in     std_logic;
    wb_adr_i                                 : in     std_logic_vector(13 downto 0);
    wb_dat_i                                 : in     std_logic_vector(31 downto 0);
    wb_dat_o                                 : out    std_logic_vector(31 downto 0);
    wb_cyc_i                                 : in     std_logic;
    wb_sel_i                                 : in     std_logic_vector(3 downto 0);
    wb_stb_i                                 : in     std_logic;
    wb_we_i                                  : in     std_logic;
    wb_ack_o                                 : out    std_logic;
    wb_stall_o                               : out    std_logic;
    clk_rf_ik                                : in     std_logic;
-- Ports for RAM: CH1 SET serial stream
    ffpg_ch1_set_mem_addr_i                  : in     std_logic_vector(10 downto 0);
-- Read data output
    ffpg_ch1_set_mem_data_o                  : out    std_logic_vector(31 downto 0);
-- Read strobe input (active high)
    ffpg_ch1_set_mem_rd_i                    : in     std_logic;
-- Ports for RAM: CH1 RES serial stream
    ffpg_ch1_res_mem_addr_i                  : in     std_logic_vector(10 downto 0);
-- Read data output
    ffpg_ch1_res_mem_data_o                  : out    std_logic_vector(31 downto 0);
-- Read strobe input (active high)
    ffpg_ch1_res_mem_rd_i                    : in     std_logic;
-- Ports for RAM: CH2 SET serial stream
    ffpg_ch2_set_mem_addr_i                  : in     std_logic_vector(10 downto 0);
-- Read data output
    ffpg_ch2_set_mem_data_o                  : out    std_logic_vector(31 downto 0);
-- Read strobe input (active high)
    ffpg_ch2_set_mem_rd_i                    : in     std_logic;
-- Ports for RAM: CH2 RES serial stream
    ffpg_ch2_res_mem_addr_i                  : in     std_logic_vector(10 downto 0);
-- Read data output
    ffpg_ch2_res_mem_data_o                  : out    std_logic_vector(31 downto 0);
-- Read strobe input (active high)
    ffpg_ch2_res_mem_rd_i                    : in     std_logic;
    regs_i                                   : in     t_ffpg_in_registers;
    regs_o                                   : out    t_ffpg_out_registers
  );
end ffpg_csr;

architecture syn of ffpg_csr is

  signal ffpg_control_clock_selection_int         : std_logic_vector(1 downto 0);
  signal ffpg_control_ch1_oe_int                  : std_logic;
  signal ffpg_control_ch2_oe_int                  : std_logic;
  signal ffpg_control_ch1_mode_int                : std_logic_vector(1 downto 0);
  signal ffpg_control_ch2_mode_int                : std_logic_vector(1 downto 0);
  signal ffpg_control_led_test_int                : std_logic;
  signal ffpg_control_ad9512_sync_dly0            : std_logic;
  signal ffpg_control_ad9512_sync_int             : std_logic;
  signal ffpg_control_fine_delay_enable_int       : std_logic;
  signal ffpg_ch1_set_mem_rddata_int              : std_logic_vector(31 downto 0);
  signal ffpg_ch1_set_mem_rd_int                  : std_logic;
  signal ffpg_ch1_set_mem_wr_int                  : std_logic;
  signal ffpg_ch1_res_mem_rddata_int              : std_logic_vector(31 downto 0);
  signal ffpg_ch1_res_mem_rd_int                  : std_logic;
  signal ffpg_ch1_res_mem_wr_int                  : std_logic;
  signal ffpg_ch2_set_mem_rddata_int              : std_logic_vector(31 downto 0);
  signal ffpg_ch2_set_mem_rd_int                  : std_logic;
  signal ffpg_ch2_set_mem_wr_int                  : std_logic;
  signal ffpg_ch2_res_mem_rddata_int              : std_logic_vector(31 downto 0);
  signal ffpg_ch2_res_mem_rd_int                  : std_logic;
  signal ffpg_ch2_res_mem_wr_int                  : std_logic;
  signal ack_sreg                                 : std_logic_vector(9 downto 0);
  signal rddata_reg                               : std_logic_vector(31 downto 0);
  signal wrdata_reg                               : std_logic_vector(31 downto 0);
  signal bwsel_reg                                : std_logic_vector(3 downto 0);
  signal rwaddr_reg                               : std_logic_vector(13 downto 0);
  signal ack_in_progress                          : std_logic;
  signal wr_int                                   : std_logic;
  signal rd_int                                   : std_logic;
  signal allones                                  : std_logic_vector(31 downto 0);
  signal allzeros                                 : std_logic_vector(31 downto 0);

begin
-- Some internal signals assignments. For (foreseen) compatibility with other bus standards.
  wrdata_reg <= wb_dat_i;
  bwsel_reg <= wb_sel_i;
  rd_int <= wb_cyc_i and (wb_stb_i and (not wb_we_i));
  wr_int <= wb_cyc_i and (wb_stb_i and wb_we_i);
  allones <= (others => '1');
  allzeros <= (others => '0');
-- 
-- Main register bank access process.
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      ack_sreg <= "0000000000";
      ack_in_progress <= '0';
      rddata_reg <= "00000000000000000000000000000000";
      ffpg_control_clock_selection_int <= "00";
      ffpg_control_ch1_oe_int <= '0';
      ffpg_control_ch2_oe_int <= '0';
      ffpg_control_ch1_mode_int <= "00";
      ffpg_control_ch2_mode_int <= "00";
      ffpg_control_led_test_int <= '0';
      ffpg_control_ad9512_sync_int <= '0';
      ffpg_control_fine_delay_enable_int <= '0';
      regs_o.vcxo_voltage_load_o <= '0';
      regs_o.clock_ratio_m1_load_o <= '0';
      regs_o.ch1_delay_set_load_o <= '0';
      regs_o.ch1_delay_reset_load_o <= '0';
      regs_o.ch2_delay_set_load_o <= '0';
      regs_o.ch2_delay_reset_load_o <= '0';
      regs_o.trigger_threshold_load_o <= '0';
      regs_o.overflow_load_o <= '0';
      regs_o.ch1_trigger_latency_load_o <= '0';
      regs_o.ch2_trigger_latency_load_o <= '0';
      regs_o.fine_delay_value_load_o <= '0';
      regs_o.fine_delay_current_load_o <= '0';
      regs_o.fine_delay_capacitors_load_o <= '0';
    elsif rising_edge(clk_sys_i) then
-- advance the ACK generator shift register
      ack_sreg(8 downto 0) <= ack_sreg(9 downto 1);
      ack_sreg(9) <= '0';
      if (ack_in_progress = '1') then
        if (ack_sreg(0) = '1') then
          ffpg_control_ad9512_sync_int <= '0';
          regs_o.vcxo_voltage_load_o <= '0';
          regs_o.clock_ratio_m1_load_o <= '0';
          regs_o.ch1_delay_set_load_o <= '0';
          regs_o.ch1_delay_reset_load_o <= '0';
          regs_o.ch2_delay_set_load_o <= '0';
          regs_o.ch2_delay_reset_load_o <= '0';
          regs_o.trigger_threshold_load_o <= '0';
          regs_o.overflow_load_o <= '0';
          regs_o.ch1_trigger_latency_load_o <= '0';
          regs_o.ch2_trigger_latency_load_o <= '0';
          regs_o.fine_delay_value_load_o <= '0';
          regs_o.fine_delay_current_load_o <= '0';
          regs_o.fine_delay_capacitors_load_o <= '0';
          ack_in_progress <= '0';
        else
          regs_o.vcxo_voltage_load_o <= '0';
          regs_o.clock_ratio_m1_load_o <= '0';
          regs_o.ch1_delay_set_load_o <= '0';
          regs_o.ch1_delay_reset_load_o <= '0';
          regs_o.ch2_delay_set_load_o <= '0';
          regs_o.ch2_delay_reset_load_o <= '0';
          regs_o.trigger_threshold_load_o <= '0';
          regs_o.overflow_load_o <= '0';
          regs_o.ch1_trigger_latency_load_o <= '0';
          regs_o.ch2_trigger_latency_load_o <= '0';
          regs_o.fine_delay_value_load_o <= '0';
          regs_o.fine_delay_current_load_o <= '0';
          regs_o.fine_delay_capacitors_load_o <= '0';
        end if;
      else
        if ((wb_cyc_i = '1') and (wb_stb_i = '1')) then
          case rwaddr_reg(13 downto 11) is
          when "000" => 
            case rwaddr_reg(3 downto 0) is
            when "0000" => 
              if (wb_we_i = '1') then
              end if;
              rddata_reg(0) <= regs_i.status_clock_infrastructure_busy_i;
              rddata_reg(1) <= regs_i.status_dac_vcxo_busy_i;
              rddata_reg(2) <= regs_i.status_dac_trigger_busy_i;
              rddata_reg(3) <= regs_i.status_delay_configuration_busy_i;
              rddata_reg(4) <= regs_i.status_channel_1_oe_i;
              rddata_reg(5) <= regs_i.status_channel_2_oe_i;
              rddata_reg(6) <= regs_i.status_channel_1_running_i;
              rddata_reg(7) <= regs_i.status_channel_2_running_i;
              rddata_reg(8) <= regs_i.status_input_clock_stable_i;
              rddata_reg(31 downto 9) <= (others => 'X');
              ack_sreg(0) <= '1';
              ack_in_progress <= '1';
            when "0001" => 
              if (wb_we_i = '1') then
                ffpg_control_clock_selection_int <= wrdata_reg(1 downto 0);
                ffpg_control_ch1_oe_int <= wrdata_reg(2);
                ffpg_control_ch2_oe_int <= wrdata_reg(3);
                ffpg_control_ch1_mode_int <= wrdata_reg(5 downto 4);
                ffpg_control_ch2_mode_int <= wrdata_reg(7 downto 6);
                ffpg_control_led_test_int <= wrdata_reg(8);
                ffpg_control_ad9512_sync_int <= wrdata_reg(9);
                ffpg_control_fine_delay_enable_int <= wrdata_reg(10);
              end if;
              rddata_reg(1 downto 0) <= ffpg_control_clock_selection_int;
              rddata_reg(2) <= ffpg_control_ch1_oe_int;
              rddata_reg(3) <= ffpg_control_ch2_oe_int;
              rddata_reg(5 downto 4) <= ffpg_control_ch1_mode_int;
              rddata_reg(7 downto 6) <= ffpg_control_ch2_mode_int;
              rddata_reg(8) <= ffpg_control_led_test_int;
              rddata_reg(9) <= '0';
              rddata_reg(10) <= ffpg_control_fine_delay_enable_int;
              rddata_reg(31 downto 11) <= (others => 'X');
              ack_sreg(2) <= '1';
              ack_in_progress <= '1';
            when "0010" => 
              if (wb_we_i = '1') then
                regs_o.vcxo_voltage_load_o <= '1';
              end if;
              rddata_reg(15 downto 0) <= std_logic_vector(regs_i.vcxo_voltage_i);
              rddata_reg(31 downto 16) <= (others => 'X');
              ack_sreg(0) <= '1';
              ack_in_progress <= '1';
            when "0011" => 
              if (wb_we_i = '1') then
                regs_o.clock_ratio_m1_load_o <= '1';
              end if;
              rddata_reg(4 downto 0) <= std_logic_vector(regs_i.clock_ratio_m1_i);
              rddata_reg(31 downto 5) <= (others => 'X');
              ack_sreg(0) <= '1';
              ack_in_progress <= '1';
            when "0100" => 
              if (wb_we_i = '1') then
                regs_o.ch1_delay_set_load_o <= '1';
              end if;
              rddata_reg(9 downto 0) <= std_logic_vector(regs_i.ch1_delay_set_i);
              rddata_reg(31 downto 10) <= (others => 'X');
              ack_sreg(0) <= '1';
              ack_in_progress <= '1';
            when "0101" => 
              if (wb_we_i = '1') then
                regs_o.ch1_delay_reset_load_o <= '1';
              end if;
              rddata_reg(9 downto 0) <= std_logic_vector(regs_i.ch1_delay_reset_i);
              rddata_reg(31 downto 10) <= (others => 'X');
              ack_sreg(0) <= '1';
              ack_in_progress <= '1';
            when "0110" => 
              if (wb_we_i = '1') then
                regs_o.ch2_delay_set_load_o <= '1';
              end if;
              rddata_reg(9 downto 0) <= std_logic_vector(regs_i.ch2_delay_set_i);
              rddata_reg(31 downto 10) <= (others => 'X');
              ack_sreg(0) <= '1';
              ack_in_progress <= '1';
            when "0111" => 
              if (wb_we_i = '1') then
                regs_o.ch2_delay_reset_load_o <= '1';
              end if;
              rddata_reg(9 downto 0) <= std_logic_vector(regs_i.ch2_delay_reset_i);
              rddata_reg(31 downto 10) <= (others => 'X');
              ack_sreg(0) <= '1';
              ack_in_progress <= '1';
            when "1000" => 
              if (wb_we_i = '1') then
                regs_o.trigger_threshold_load_o <= '1';
              end if;
              rddata_reg(15 downto 0) <= std_logic_vector(regs_i.trigger_threshold_i);
              rddata_reg(31 downto 16) <= (others => 'X');
              ack_sreg(0) <= '1';
              ack_in_progress <= '1';
            when "1001" => 
              if (wb_we_i = '1') then
                regs_o.overflow_load_o <= '1';
              end if;
              rddata_reg(15 downto 0) <= std_logic_vector(regs_i.overflow_i);
              rddata_reg(31 downto 16) <= (others => 'X');
              ack_sreg(0) <= '1';
              ack_in_progress <= '1';
            when "1010" => 
              if (wb_we_i = '1') then
                regs_o.ch1_trigger_latency_load_o <= '1';
              end if;
              rddata_reg(15 downto 0) <= std_logic_vector(regs_i.ch1_trigger_latency_i);
              rddata_reg(31 downto 16) <= (others => 'X');
              ack_sreg(0) <= '1';
              ack_in_progress <= '1';
            when "1011" => 
              if (wb_we_i = '1') then
              end if;
              rddata_reg(31 downto 0) <= std_logic_vector(regs_i.frequency_i);
              ack_sreg(0) <= '1';
              ack_in_progress <= '1';
            when "1100" => 
              if (wb_we_i = '1') then
              end if;
              rddata_reg(31 downto 0) <= std_logic_vector(regs_i.debug_i);
              ack_sreg(0) <= '1';
              ack_in_progress <= '1';
            when "1101" => 
              if (wb_we_i = '1') then
              end if;
              rddata_reg(11 downto 0) <= std_logic_vector(regs_i.version_revision_i);
              rddata_reg(21 downto 12) <= std_logic_vector(regs_i.version_minor_i);
              rddata_reg(31 downto 22) <= std_logic_vector(regs_i.version_major_i);
              ack_sreg(0) <= '1';
              ack_in_progress <= '1';
            when "1110" => 
              if (wb_we_i = '1') then
                regs_o.ch2_trigger_latency_load_o <= '1';
              end if;
              rddata_reg(15 downto 0) <= std_logic_vector(regs_i.ch2_trigger_latency_i);
              rddata_reg(31 downto 16) <= (others => 'X');
              ack_sreg(0) <= '1';
              ack_in_progress <= '1';
            when "1111" => 
              if (wb_we_i = '1') then
                regs_o.fine_delay_value_load_o <= '1';
                regs_o.fine_delay_current_load_o <= '1';
                regs_o.fine_delay_capacitors_load_o <= '1';
              end if;
              rddata_reg(4 downto 0) <= std_logic_vector(regs_i.fine_delay_value_i);
              rddata_reg(7 downto 5) <= std_logic_vector(regs_i.fine_delay_current_i);
              rddata_reg(10 downto 8) <= std_logic_vector(regs_i.fine_delay_capacitors_i);
              rddata_reg(31 downto 11) <= (others => 'X');
              ack_sreg(0) <= '1';
              ack_in_progress <= '1';
            when others =>
-- prevent the slave from hanging the bus on invalid address
              ack_in_progress <= '1';
              ack_sreg(0) <= '1';
            end case;
          when "001" => 
            if (rd_int = '1') then
              ack_sreg(0) <= '1';
            else
              ack_sreg(0) <= '1';
            end if;
            ack_in_progress <= '1';
          when "010" => 
            if (rd_int = '1') then
              ack_sreg(0) <= '1';
            else
              ack_sreg(0) <= '1';
            end if;
            ack_in_progress <= '1';
          when "011" => 
            if (rd_int = '1') then
              ack_sreg(0) <= '1';
            else
              ack_sreg(0) <= '1';
            end if;
            ack_in_progress <= '1';
          when "100" => 
            if (rd_int = '1') then
              ack_sreg(0) <= '1';
            else
              ack_sreg(0) <= '1';
            end if;
            ack_in_progress <= '1';
          when others =>
-- prevent the slave from hanging the bus on invalid address
            ack_in_progress <= '1';
            ack_sreg(0) <= '1';
          end case;
        end if;
      end if;
    end if;
  end process;
  
  
-- Data output multiplexer process
  process (rddata_reg, rwaddr_reg, ffpg_ch1_set_mem_rddata_int, ffpg_ch1_res_mem_rddata_int, ffpg_ch2_set_mem_rddata_int, ffpg_ch2_res_mem_rddata_int, wb_adr_i  )
  begin
    case rwaddr_reg(13 downto 11) is
    when "001" => 
      wb_dat_o(31 downto 0) <= ffpg_ch1_set_mem_rddata_int;
    when "010" => 
      wb_dat_o(31 downto 0) <= ffpg_ch1_res_mem_rddata_int;
    when "011" => 
      wb_dat_o(31 downto 0) <= ffpg_ch2_set_mem_rddata_int;
    when "100" => 
      wb_dat_o(31 downto 0) <= ffpg_ch2_res_mem_rddata_int;
    when others =>
      wb_dat_o <= rddata_reg;
    end case;
  end process;
  
  
-- Read & write lines decoder for RAMs
  process (wb_adr_i, rd_int, wr_int  )
  begin
    if (wb_adr_i(13 downto 11) = "001") then
      ffpg_ch1_set_mem_rd_int <= rd_int;
      ffpg_ch1_set_mem_wr_int <= wr_int;
    else
      ffpg_ch1_set_mem_wr_int <= '0';
      ffpg_ch1_set_mem_rd_int <= '0';
    end if;
    if (wb_adr_i(13 downto 11) = "010") then
      ffpg_ch1_res_mem_rd_int <= rd_int;
      ffpg_ch1_res_mem_wr_int <= wr_int;
    else
      ffpg_ch1_res_mem_wr_int <= '0';
      ffpg_ch1_res_mem_rd_int <= '0';
    end if;
    if (wb_adr_i(13 downto 11) = "011") then
      ffpg_ch2_set_mem_rd_int <= rd_int;
      ffpg_ch2_set_mem_wr_int <= wr_int;
    else
      ffpg_ch2_set_mem_wr_int <= '0';
      ffpg_ch2_set_mem_rd_int <= '0';
    end if;
    if (wb_adr_i(13 downto 11) = "100") then
      ffpg_ch2_res_mem_rd_int <= rd_int;
      ffpg_ch2_res_mem_wr_int <= wr_int;
    else
      ffpg_ch2_res_mem_wr_int <= '0';
      ffpg_ch2_res_mem_rd_int <= '0';
    end if;
  end process;
  
  
-- Clock source selection
  regs_o.control_clock_selection_o <= ffpg_control_clock_selection_int;
-- CH1 output enable
  regs_o.control_ch1_oe_o <= ffpg_control_ch1_oe_int;
-- CH2 output enable
  regs_o.control_ch2_oe_o <= ffpg_control_ch2_oe_int;
-- CH1 mode selection
  regs_o.control_ch1_mode_o <= ffpg_control_ch1_mode_int;
-- CH2 mode selection
  regs_o.control_ch2_mode_o <= ffpg_control_ch2_mode_int;
-- LED test
  regs_o.control_led_test_o <= ffpg_control_led_test_int;
-- AD9512 Synchronization
  process (clk_sys_i, rst_n_i)
  begin
    if (rst_n_i = '0') then 
      ffpg_control_ad9512_sync_dly0 <= '0';
      regs_o.control_ad9512_sync_o <= '0';
    elsif rising_edge(clk_sys_i) then
      ffpg_control_ad9512_sync_dly0 <= ffpg_control_ad9512_sync_int;
      regs_o.control_ad9512_sync_o <= ffpg_control_ad9512_sync_int and (not ffpg_control_ad9512_sync_dly0);
    end if;
  end process;
  
  
-- AD9512 OUT4 fine delay enable
  regs_o.control_fine_delay_enable_o <= ffpg_control_fine_delay_enable_int;
-- VCXO voltage register value
  regs_o.vcxo_voltage_o <= unsigned(wrdata_reg(15 downto 0));
-- Clock ratio-1
  regs_o.clock_ratio_m1_o <= unsigned(wrdata_reg(4 downto 0));
-- CH1 SET delay
  regs_o.ch1_delay_set_o <= unsigned(wrdata_reg(9 downto 0));
-- CH1 RES delay
  regs_o.ch1_delay_reset_o <= unsigned(wrdata_reg(9 downto 0));
-- CH2 SET delay
  regs_o.ch2_delay_set_o <= unsigned(wrdata_reg(9 downto 0));
-- CH2 RES delay
  regs_o.ch2_delay_reset_o <= unsigned(wrdata_reg(9 downto 0));
-- Trigger threshold voltage register value
  regs_o.trigger_threshold_o <= unsigned(wrdata_reg(15 downto 0));
-- Overflow value
  regs_o.overflow_o <= unsigned(wrdata_reg(15 downto 0));
-- Trigger latency value
  regs_o.ch1_trigger_latency_o <= unsigned(wrdata_reg(15 downto 0));
-- Trigger latency value
  regs_o.ch2_trigger_latency_o <= unsigned(wrdata_reg(15 downto 0));
-- AD9512 OUT4 fine delay value
  regs_o.fine_delay_value_o <= unsigned(wrdata_reg(4 downto 0));
-- Ramp current
  regs_o.fine_delay_current_o <= unsigned(wrdata_reg(7 downto 5));
-- Ramp capacitors
  regs_o.fine_delay_capacitors_o <= unsigned(wrdata_reg(10 downto 8));
-- extra code for reg/fifo/mem: CH1 SET serial stream
-- RAM block instantiation for memory: CH1 SET serial stream
  ffpg_ch1_set_mem_raminst : wbgen2_dpssram
    generic map (
      g_data_width         => 32,
      g_size               => 2048,
      g_addr_width         => 11,
      g_dual_clock         => true,
      g_use_bwsel          => false
    )
    port map (
      clk_a_i              => clk_sys_i,
      clk_b_i              => clk_rf_ik,
      addr_b_i             => ffpg_ch1_set_mem_addr_i,
      addr_a_i             => rwaddr_reg(10 downto 0),
      data_b_o             => ffpg_ch1_set_mem_data_o,
      rd_b_i               => ffpg_ch1_set_mem_rd_i,
      bwsel_b_i            => allones(3 downto 0),
      data_b_i             => allzeros(31 downto 0),
      wr_b_i               => allzeros(0),
      data_a_o             => ffpg_ch1_set_mem_rddata_int(31 downto 0),
      rd_a_i               => ffpg_ch1_set_mem_rd_int,
      data_a_i             => wrdata_reg(31 downto 0),
      wr_a_i               => ffpg_ch1_set_mem_wr_int,
      bwsel_a_i            => allones(3 downto 0)
    );
  
-- extra code for reg/fifo/mem: CH1 RES serial stream
-- RAM block instantiation for memory: CH1 RES serial stream
  ffpg_ch1_res_mem_raminst : wbgen2_dpssram
    generic map (
      g_data_width         => 32,
      g_size               => 2048,
      g_addr_width         => 11,
      g_dual_clock         => true,
      g_use_bwsel          => false
    )
    port map (
      clk_a_i              => clk_sys_i,
      clk_b_i              => clk_rf_ik,
      addr_b_i             => ffpg_ch1_res_mem_addr_i,
      addr_a_i             => rwaddr_reg(10 downto 0),
      data_b_o             => ffpg_ch1_res_mem_data_o,
      rd_b_i               => ffpg_ch1_res_mem_rd_i,
      bwsel_b_i            => allones(3 downto 0),
      data_b_i             => allzeros(31 downto 0),
      wr_b_i               => allzeros(0),
      data_a_o             => ffpg_ch1_res_mem_rddata_int(31 downto 0),
      rd_a_i               => ffpg_ch1_res_mem_rd_int,
      data_a_i             => wrdata_reg(31 downto 0),
      wr_a_i               => ffpg_ch1_res_mem_wr_int,
      bwsel_a_i            => allones(3 downto 0)
    );
  
-- extra code for reg/fifo/mem: CH2 SET serial stream
-- RAM block instantiation for memory: CH2 SET serial stream
  ffpg_ch2_set_mem_raminst : wbgen2_dpssram
    generic map (
      g_data_width         => 32,
      g_size               => 2048,
      g_addr_width         => 11,
      g_dual_clock         => true,
      g_use_bwsel          => false
    )
    port map (
      clk_a_i              => clk_sys_i,
      clk_b_i              => clk_rf_ik,
      addr_b_i             => ffpg_ch2_set_mem_addr_i,
      addr_a_i             => rwaddr_reg(10 downto 0),
      data_b_o             => ffpg_ch2_set_mem_data_o,
      rd_b_i               => ffpg_ch2_set_mem_rd_i,
      bwsel_b_i            => allones(3 downto 0),
      data_b_i             => allzeros(31 downto 0),
      wr_b_i               => allzeros(0),
      data_a_o             => ffpg_ch2_set_mem_rddata_int(31 downto 0),
      rd_a_i               => ffpg_ch2_set_mem_rd_int,
      data_a_i             => wrdata_reg(31 downto 0),
      wr_a_i               => ffpg_ch2_set_mem_wr_int,
      bwsel_a_i            => allones(3 downto 0)
    );
  
-- extra code for reg/fifo/mem: CH2 RES serial stream
-- RAM block instantiation for memory: CH2 RES serial stream
  ffpg_ch2_res_mem_raminst : wbgen2_dpssram
    generic map (
      g_data_width         => 32,
      g_size               => 2048,
      g_addr_width         => 11,
      g_dual_clock         => true,
      g_use_bwsel          => false
    )
    port map (
      clk_a_i              => clk_sys_i,
      clk_b_i              => clk_rf_ik,
      addr_b_i             => ffpg_ch2_res_mem_addr_i,
      addr_a_i             => rwaddr_reg(10 downto 0),
      data_b_o             => ffpg_ch2_res_mem_data_o,
      rd_b_i               => ffpg_ch2_res_mem_rd_i,
      bwsel_b_i            => allones(3 downto 0),
      data_b_i             => allzeros(31 downto 0),
      wr_b_i               => allzeros(0),
      data_a_o             => ffpg_ch2_res_mem_rddata_int(31 downto 0),
      rd_a_i               => ffpg_ch2_res_mem_rd_int,
      data_a_i             => wrdata_reg(31 downto 0),
      wr_a_i               => ffpg_ch2_res_mem_wr_int,
      bwsel_a_i            => allones(3 downto 0)
    );
  
  rwaddr_reg <= wb_adr_i;
  wb_stall_o <= (not ack_sreg(0)) and (ack_in_progress or (wb_stb_i and wb_cyc_i));
-- ACK signal generation. Just pass the LSB of ACK counter.
  wb_ack_o <= ack_sreg(0);
end syn;
