---------------------------------------------------------------------------------------
-- Title          : Wishbone slave core for FMC DEL 1ns 2cha core registers
---------------------------------------------------------------------------------------
-- File           : ../rtl/ffpg_csr_pkg.vhd
-- Author         : auto-generated by wbgen2 from ffpg_csr.wb
-- Created        : 12/19/16 17:04:33
-- Standard       : VHDL'87
---------------------------------------------------------------------------------------
-- THIS FILE WAS GENERATED BY wbgen2 FROM SOURCE FILE ffpg_csr.wb
-- DO NOT HAND-EDIT UNLESS IT'S ABSOLUTELY NECESSARY!
---------------------------------------------------------------------------------------

library ieee;
use ieee.std_logic_1164.all;
use ieee.numeric_std.all;
use work.wbgen2_pkg.all;

package ffpg_wbgen2_pkg is
  
  -- Constants
  constant c_ffpg_address_width: natural := 14;
  
  -- Input registers (user design -> WB slave)
  
  type t_ffpg_in_registers is record
    status_clock_infrastructure_busy_i       : std_logic;
    status_dac_vcxo_busy_i                   : std_logic;
    status_dac_trigger_busy_i                : std_logic;
    status_delay_configuration_busy_i        : std_logic;
    status_channel_1_oe_i                    : std_logic;
    status_channel_2_oe_i                    : std_logic;
    status_channel_1_running_i               : std_logic;
    status_channel_2_running_i               : std_logic;
    status_input_clock_stable_i              : std_logic;
    vcxo_voltage_i                           : unsigned(15 downto 0);
    clock_ratio_m1_i                         : unsigned(4 downto 0);
    ch1_delay_set_i                          : unsigned(9 downto 0);
    ch1_delay_reset_i                        : unsigned(9 downto 0);
    ch2_delay_set_i                          : unsigned(9 downto 0);
    ch2_delay_reset_i                        : unsigned(9 downto 0);
    trigger_threshold_i                      : unsigned(15 downto 0);
    overflow_i                               : unsigned(15 downto 0);
    ch1_trigger_latency_i                    : unsigned(15 downto 0);
    frequency_i                              : unsigned(31 downto 0);
    debug_i                                  : unsigned(31 downto 0);
    version_revision_i                       : unsigned(11 downto 0);
    version_minor_i                          : unsigned(9 downto 0);
    version_major_i                          : unsigned(9 downto 0);
    ch2_trigger_latency_i                    : unsigned(15 downto 0);
    fine_delay_value_i                       : unsigned(4 downto 0);
    fine_delay_current_i                     : unsigned(2 downto 0);
    fine_delay_capacitors_i                  : unsigned(2 downto 0);
    end record;
  
  constant c_ffpg_in_registers_init_value: t_ffpg_in_registers := (
    status_clock_infrastructure_busy_i => '0',
    status_dac_vcxo_busy_i => '0',
    status_dac_trigger_busy_i => '0',
    status_delay_configuration_busy_i => '0',
    status_channel_1_oe_i => '0',
    status_channel_2_oe_i => '0',
    status_channel_1_running_i => '0',
    status_channel_2_running_i => '0',
    status_input_clock_stable_i => '0',
    vcxo_voltage_i => (others => '0'),
    clock_ratio_m1_i => (others => '0'),
    ch1_delay_set_i => (others => '0'),
    ch1_delay_reset_i => (others => '0'),
    ch2_delay_set_i => (others => '0'),
    ch2_delay_reset_i => (others => '0'),
    trigger_threshold_i => (others => '0'),
    overflow_i => (others => '0'),
    ch1_trigger_latency_i => (others => '0'),
    frequency_i => (others => '0'),
    debug_i => (others => '0'),
    version_revision_i => (others => '0'),
    version_minor_i => (others => '0'),
    version_major_i => (others => '0'),
    ch2_trigger_latency_i => (others => '0'),
    fine_delay_value_i => (others => '0'),
    fine_delay_current_i => (others => '0'),
    fine_delay_capacitors_i => (others => '0')
    );
  
  -- Output registers (WB slave -> user design)
  
  type t_ffpg_out_registers is record
    control_clock_selection_o                : std_logic_vector(1 downto 0);
    control_ch1_oe_o                         : std_logic;
    control_ch2_oe_o                         : std_logic;
    control_ch1_mode_o                       : std_logic_vector(1 downto 0);
    control_ch2_mode_o                       : std_logic_vector(1 downto 0);
    control_led_test_o                       : std_logic;
    control_ad9512_sync_o                    : std_logic;
    control_fine_delay_enable_o              : std_logic;
    vcxo_voltage_o                           : unsigned(15 downto 0);
    vcxo_voltage_load_o                      : std_logic;
    clock_ratio_m1_o                         : unsigned(4 downto 0);
    clock_ratio_m1_load_o                    : std_logic;
    ch1_delay_set_o                          : unsigned(9 downto 0);
    ch1_delay_set_load_o                     : std_logic;
    ch1_delay_reset_o                        : unsigned(9 downto 0);
    ch1_delay_reset_load_o                   : std_logic;
    ch2_delay_set_o                          : unsigned(9 downto 0);
    ch2_delay_set_load_o                     : std_logic;
    ch2_delay_reset_o                        : unsigned(9 downto 0);
    ch2_delay_reset_load_o                   : std_logic;
    trigger_threshold_o                      : unsigned(15 downto 0);
    trigger_threshold_load_o                 : std_logic;
    overflow_o                               : unsigned(15 downto 0);
    overflow_load_o                          : std_logic;
    ch1_trigger_latency_o                    : unsigned(15 downto 0);
    ch1_trigger_latency_load_o               : std_logic;
    ch2_trigger_latency_o                    : unsigned(15 downto 0);
    ch2_trigger_latency_load_o               : std_logic;
    fine_delay_value_o                       : unsigned(4 downto 0);
    fine_delay_value_load_o                  : std_logic;
    fine_delay_current_o                     : unsigned(2 downto 0);
    fine_delay_current_load_o                : std_logic;
    fine_delay_capacitors_o                  : unsigned(2 downto 0);
    fine_delay_capacitors_load_o             : std_logic;
    end record;
  
  constant c_ffpg_out_registers_init_value: t_ffpg_out_registers := (
    control_clock_selection_o => (others => '0'),
    control_ch1_oe_o => '0',
    control_ch2_oe_o => '0',
    control_ch1_mode_o => (others => '0'),
    control_ch2_mode_o => (others => '0'),
    control_led_test_o => '0',
    control_ad9512_sync_o => '0',
    control_fine_delay_enable_o => '0',
    vcxo_voltage_o => (others => '0'),
    vcxo_voltage_load_o => '0',
    clock_ratio_m1_o => (others => '0'),
    clock_ratio_m1_load_o => '0',
    ch1_delay_set_o => (others => '0'),
    ch1_delay_set_load_o => '0',
    ch1_delay_reset_o => (others => '0'),
    ch1_delay_reset_load_o => '0',
    ch2_delay_set_o => (others => '0'),
    ch2_delay_set_load_o => '0',
    ch2_delay_reset_o => (others => '0'),
    ch2_delay_reset_load_o => '0',
    trigger_threshold_o => (others => '0'),
    trigger_threshold_load_o => '0',
    overflow_o => (others => '0'),
    overflow_load_o => '0',
    ch1_trigger_latency_o => (others => '0'),
    ch1_trigger_latency_load_o => '0',
    ch2_trigger_latency_o => (others => '0'),
    ch2_trigger_latency_load_o => '0',
    fine_delay_value_o => (others => '0'),
    fine_delay_value_load_o => '0',
    fine_delay_current_o => (others => '0'),
    fine_delay_current_load_o => '0',
    fine_delay_capacitors_o => (others => '0'),
    fine_delay_capacitors_load_o => '0'
    );
  
  -- functions
  
  function f_x_to_zero (x:std_logic) return std_logic;
  function f_x_to_zero (x:std_logic_vector) return std_logic_vector;
  function f_x_to_zero (x:signed) return signed;
  function f_x_to_zero (x:unsigned) return unsigned;
  function "or" (left, right: t_ffpg_in_registers) return t_ffpg_in_registers;
  
end package;

package body ffpg_wbgen2_pkg is
  
  function f_x_to_zero (x:std_logic) return std_logic is
  begin
    if x = '1' then
      return '1';
    else
      return '0';
    end if;
  end function;
  
  function f_x_to_zero (x:std_logic_vector) return std_logic_vector is
    variable tmp: std_logic_vector(x'length-1 downto 0);
  begin
    for i in 0 to x'length-1 loop
      if(x(i) = 'X' or x(i) = 'U') then
        tmp(i):= '0';
      else
        tmp(i):=x(i);
      end if; 
    end loop; 
    return tmp;
  end function;
  
  function f_x_to_zero (x:signed) return signed is
  begin
    return signed(f_x_to_zero(std_logic_vector(x)));
  end function;
  
  function f_x_to_zero (x:unsigned) return unsigned is
  begin
    return unsigned(f_x_to_zero(std_logic_vector(x)));
  end function;
  
  function "or" (left, right: t_ffpg_in_registers) return t_ffpg_in_registers is
    variable tmp: t_ffpg_in_registers;
  begin
    tmp.status_clock_infrastructure_busy_i := f_x_to_zero(left.status_clock_infrastructure_busy_i) or f_x_to_zero(right.status_clock_infrastructure_busy_i);
    tmp.status_dac_vcxo_busy_i := f_x_to_zero(left.status_dac_vcxo_busy_i) or f_x_to_zero(right.status_dac_vcxo_busy_i);
    tmp.status_dac_trigger_busy_i := f_x_to_zero(left.status_dac_trigger_busy_i) or f_x_to_zero(right.status_dac_trigger_busy_i);
    tmp.status_delay_configuration_busy_i := f_x_to_zero(left.status_delay_configuration_busy_i) or f_x_to_zero(right.status_delay_configuration_busy_i);
    tmp.status_channel_1_oe_i := f_x_to_zero(left.status_channel_1_oe_i) or f_x_to_zero(right.status_channel_1_oe_i);
    tmp.status_channel_2_oe_i := f_x_to_zero(left.status_channel_2_oe_i) or f_x_to_zero(right.status_channel_2_oe_i);
    tmp.status_channel_1_running_i := f_x_to_zero(left.status_channel_1_running_i) or f_x_to_zero(right.status_channel_1_running_i);
    tmp.status_channel_2_running_i := f_x_to_zero(left.status_channel_2_running_i) or f_x_to_zero(right.status_channel_2_running_i);
    tmp.status_input_clock_stable_i := f_x_to_zero(left.status_input_clock_stable_i) or f_x_to_zero(right.status_input_clock_stable_i);
    tmp.vcxo_voltage_i := f_x_to_zero(left.vcxo_voltage_i) or f_x_to_zero(right.vcxo_voltage_i);
    tmp.clock_ratio_m1_i := f_x_to_zero(left.clock_ratio_m1_i) or f_x_to_zero(right.clock_ratio_m1_i);
    tmp.ch1_delay_set_i := f_x_to_zero(left.ch1_delay_set_i) or f_x_to_zero(right.ch1_delay_set_i);
    tmp.ch1_delay_reset_i := f_x_to_zero(left.ch1_delay_reset_i) or f_x_to_zero(right.ch1_delay_reset_i);
    tmp.ch2_delay_set_i := f_x_to_zero(left.ch2_delay_set_i) or f_x_to_zero(right.ch2_delay_set_i);
    tmp.ch2_delay_reset_i := f_x_to_zero(left.ch2_delay_reset_i) or f_x_to_zero(right.ch2_delay_reset_i);
    tmp.trigger_threshold_i := f_x_to_zero(left.trigger_threshold_i) or f_x_to_zero(right.trigger_threshold_i);
    tmp.overflow_i := f_x_to_zero(left.overflow_i) or f_x_to_zero(right.overflow_i);
    tmp.ch1_trigger_latency_i := f_x_to_zero(left.ch1_trigger_latency_i) or f_x_to_zero(right.ch1_trigger_latency_i);
    tmp.frequency_i := f_x_to_zero(left.frequency_i) or f_x_to_zero(right.frequency_i);
    tmp.debug_i := f_x_to_zero(left.debug_i) or f_x_to_zero(right.debug_i);
    tmp.version_revision_i := f_x_to_zero(left.version_revision_i) or f_x_to_zero(right.version_revision_i);
    tmp.version_minor_i := f_x_to_zero(left.version_minor_i) or f_x_to_zero(right.version_minor_i);
    tmp.version_major_i := f_x_to_zero(left.version_major_i) or f_x_to_zero(right.version_major_i);
    tmp.ch2_trigger_latency_i := f_x_to_zero(left.ch2_trigger_latency_i) or f_x_to_zero(right.ch2_trigger_latency_i);
    tmp.fine_delay_value_i := f_x_to_zero(left.fine_delay_value_i) or f_x_to_zero(right.fine_delay_value_i);
    tmp.fine_delay_current_i := f_x_to_zero(left.fine_delay_current_i) or f_x_to_zero(right.fine_delay_current_i);
    tmp.fine_delay_capacitors_i := f_x_to_zero(left.fine_delay_capacitors_i) or f_x_to_zero(right.fine_delay_capacitors_i);
    return tmp;
  end function;
  
end package body;
